//anova - jednoduché třídění
function [p_hodnota,T]=anova_1(y,n)
    //p_hodnota... p-hodnota
    //T ... statistika náhodné veličiny
    //y ... matice dat - skupiny po sloupcich (zadat jen y)') nebo vektor vyberu usporadanych za sebou')
    //n ... vektor delek jednotlivych vyberu')
    if argn(2)==1
        [nr ns]=size(y);
        n=ones(1,ns)*nr;
    end
    x=list();
    nn=[0 cumsum(n)];
    a=length(n);
    for i=1:a
        x(i)=y(nn(i)+1:nn(i+1));
    end
    for i=1:a
        n(i)=max(size(x(i)));
    end
    df=n-1;
    s=0;
    for i=1:a
        mx(i)=mean(x(i));
        s=s+n(i)*mx(i);
    end
    xx=s/sum(n);
    ssb=0; ssw=0;
    for i=1:a
        ssb=ssb+n(i)*(mx(i)-xx)^2;
        ssw=ssw+df(i)*variance(x(i));
    end
    ssc=ssb+ssw;
    dfb=a-1;
    dfw=sum(df);
    dfc=dfb+dfw;
    msb=ssb/dfb;
    msw=ssw/dfw;
    T=msb/msw;
    [P,p_hodnota]=cdff("PQ",T,dfb,dfw);
endfunction

//anova - dvojné třídění
function [pv_col, pv_row]=anova_2(s)
    //pv_col ... p-hodnota pro sloupce (1. faktor)')
    //pv_row ... p-hodnota pro radky   (2. faktor)')
    //s ... matice dat - 1. faktor sloupce', 2. faktor radky

    [a b]=size(s);                      // poè. øádkù, poè. sloupcù
    ms1=mean(s,1);                        // øádek prùmìrù sloupcù
    ms2=mean(s,2);                      // sloupec prùmìrù øádkù
    ss =mean(s(:));                     // celkový prùmìr
    S1 =a*sum((ms1-ss).^2);                // suma odchylek øádkù
    S2 =b*sum((ms2-ss).^2);                // suma odchylek sloupcù
    sh =ones(a,1)*ms1+ms2*ones(1,b)-ss; // predikce
    sx =s-sh;                           // rezidua
    SR =sum((sx(:)).^2);                   // suma reziduálních ètvercù
    df1=b-1;                            // stupnì volnosti pro ø.
    df2=a-1;                            // stupnì volnosti pro sl.
    dfR=df1*df2;                        // reziduální stupnì volnosti
    MS1=S1/df1;                         // efekt sloupcù
    MS2=S2/df2;                         // efekt øádkù
    MSR=SR/(df1*df2);                   // reziduální efekt
    T1 =MS1/MSR;                        // stat. pro sloupce
    T2 =MS2/MSR;                        // stat. pro øádky
    [P,pv_col]=cdff("PQ",T1,df1,dfR);   // p-hodnota pro sloupce
    [P,pv_row]=cdff("PQ",T2,df2,dfR);   // p-hodnota pro řádky
endfunction


