function j=ranks(a)
  // ranks of a discrete random variable
  // j  ranks, i.e. for a=[3 5 2 2] we get j=[3 4 1.5 1.5]
  //    for equal values in a, we set average rank
  // a  vector of discrete (and maybe also real) values
  [u,i]=gsort(a,'g','i');
  [xx,j]=gsort(i,'g','i');

  av=u(1);
  for i=2:length(a)
    if abs(u(i-1)-u(i))>1e-8
      av=[av u(i)];
    end
  end
  for i=1:length(av)
    ia=find(abs(a-av(i))<1e-8)
    if length(ia)>1
      k=j(ia);
      j(ia)=mean(k);
    end
  end
endfunction
